commit f22f6ae33879150b20bccc39b2f7033510af163c
Author: freddy77 <freddy77>
Date:   Sun Aug 17 20:46:24 2008 +0000

    skip empty options in SQLDriverConnect

diff --git a/ChangeLog b/ChangeLog
index 61ab07a..f32c052 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Sun Aug 17 22:45:47 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/connectparams.c:
+	- skip empty options in SQLDriverConnect to make DBD::ODBC happy
+
 Sun Aug 17 09:44:29 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/ctlib/ctutil.c src/dblib/dbutil.c src/odbc/unittests/utf8.c:
 	- remove some warnings
@@ -555,4 +559,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2588 2008/08/17 07:44:45 freddy77 Exp $
+$Id: ChangeLog,v 1.2589 2008/08/17 20:46:24 freddy77 Exp $
diff --git a/src/odbc/connectparams.c b/src/odbc/connectparams.c
index d16e218..0601176 100644
--- a/src/odbc/connectparams.c
+++ b/src/odbc/connectparams.c
@@ -37,7 +37,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: connectparams.c,v 1.74 2008/01/20 16:36:51 freddy77 Exp $");
+TDS_RCSID(var, "$Id: connectparams.c,v 1.75 2008/08/17 20:46:24 freddy77 Exp $");
 
 static const char odbc_param_Servername[] = "Servername";
 static const char odbc_param_Address[] = "Address";
@@ -226,9 +226,13 @@ odbc_parse_connect_string(const char *connect_string, const char *connect_string
 	char option[16];
 
 	tds_dstr_init(&value);
-	for (p = connect_string; p && *p;) {
+	for (p = connect_string; p < connect_string_end && *p;) {
 		dest_s = NULL;
 
+		/* handle empty options */
+		while (p < connect_string_end && *p == ';')
+			++p;
+
 		/* parse option */
 		end = (const char *) memchr(p, '=', connect_string_end - p);
 		if (!end)

